Subject: Re: [Detnet] Tsvart last call review of draft-ietf-detnet-mpls-05

From: Balázs Varga A <[email-masked]>
Date: Wed, 15 Apr 2020 07:32:02 +0000

Hi Michael,

Thanks for the review. 

The sequence number space is a circular one, similar to sequence number used in 
IEEE TSN (Time-Sensitive Networks) or rfc4385. Regarding the control word we 
refer to rfc4385. d-CW differs from rfc4385, that 0 (zero) is part of the sequence 
number space.

We have text to highlight these below Figure 5.:
" ... The values carried in this field can wrap
   and it is important to note that zero (0) is a valid field value. "

If You think that would make the text clearer I can add a specific text to highlight 
the circular characteristics of the sequence number space. This change would be 
immediately after Figure 5, where Sequence Number bits are defined.

OLD
"   Sequence Number (bits 4 to 31)
      An unsigned value implementing the DetNet sequence number."
NEW
"   Sequence Number (bits 4 to 31)
      An unsigned value implementing the DetNet sequence number.
      The sequence number space is a circular one."

Does it resolve your concerns?

Thanks
Bala'zs

-----Original Message-----
From: Michael Tüxen via Datatracker <[email-masked]> 
Sent: Sunday, March 15, 2020 11:15 PM
To: [email-masked]
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: Tsvart last call review of draft-ietf-detnet-mpls-05

Reviewer: Michael Tüxen
Review result: Ready with Issues

This document has been reviewed as part of the transport area review team's ongoing effort to review key IETF documents. These comments were written primarily for the transport area directors, but are copied to the document's authors and WG to allow them to address any issues raised and also to the IETF discussion list for information.

When done at the time of IETF Last Call, the authors should consider this review as part of the last-call comments they receive. Please always CC [email-masked] if you reply to or forward this review.

The document is in general pretty generic, so I don't know if the following was discussed on the mailing list and is described in other documents, but I think it should be described here or at least pointers to the specification describing it should be inserted.

The problems I see are related to the Sequence Number you introduce in Figure 5. If, used it is a 16-bit or 28 bit number. From the example you provide, it seems that it is used like a Serial Number as described in RFC 1982. The receiver uses this number for the PEF and POF. If this is correct, this puts a limitation regarding the number of outstanding packets on the sender. I don't see this limit being mentioned and I don't see how this limit is enforced, since there does not seem to be an acknowledgement.
The document states that an implementation MAY limit the maximum number of sequence numbers being tracked. What happens if the receiver runs out of this limit? How does a receiver protect itself against a sender playing games with the sequence number? Limiting the resources is only a MAY, so how is this done in the general case?